let fs = require('fs');
//excel的名字
const excelName = "数据模板";

let sheetNameList = ["sheet1", "sheet2"];

let RoutersheetNameList=[
    {name:"api1",dataList:[ //name:名称,len:长度,type:类型,haveUnit:是否有单位
        {name:"sheet1",len:7,type:"键值",haveUnit:true},
        {name:"sheet2",len:3,type:"柱状",haveUnit:true},
        {name:"sheet3",len:8,type:"键值",haveUnit:true},
        {name:"sheet4",len:7,type:"键值",haveUnit:true},
        {name:"sheet5",len:5,type:"地图",haveUnit:true}
    ]},
    {name:"api2",dataList:[
        {name:"sheet1",len:6,type:"键值",haveUnit:true},
        {name:"sheet2",len:1,type:"柱状",haveUnit:true},
        {name:"sheet3",len:3,type:"柱状",haveUnit:true},
    ]},
    {name:"api3",dataList:[
        {name:"sheet1",len:5,type:"地图",haveUnit:true},
        {name:"sheet2",len:6,type:"键值",haveUnit:true}
    ]}
]

//创建data层
function createData() {
    let str = `
    import * as path from "path";
    import * as fs from "fs";
    import { BizError } from "../util/bizError";
    import { limitEnteNameString } from "../util/tools";
    import { getExcelDataBySheetName, analysisExcelDataOfObject } from "../util/analysisExcel";`;



    for (let i = 0; i < sheetNameList.length; i++) {
        let sheetName = sheetNameList[i];
    str += `

    export function get${sheetName}() {;
        let bolckDataList = getExcelDataBySheetName('${excelName}', '${sheetName}');
        let result = {};
        for (let i = 0; i < bolckDataList.length; i++) {
            let {blockData, blockTitle} = bolckDataList[i];
            let analysisData = analysisExcelDataOfObject(blockData, true, true);
            result[blockTitle] = analysisData;
        }
        
        return result;
    }`;
    }

    let path = `./data/analysisExcelData.ts`;
    fs.access(path, (err) => {
        if (!err) {
            console.error(path, "文件已存在");
            return;
        }
        
        fs.writeFileSync(path,  str);
        console.log(path, "创建文件成功")
    });
}

//创建Router层
function createRouter() {
    let path = `./routers/router.ts`;
    fs.access(path, (err) => {
        if (!err) {
            console.error(path, "文件已存在");
            return;
        }
        
        fs.writeFileSync(path, getRouterData(RoutersheetNameList));
        console.log(path, "创建router文件成功")
    });
}

function getRouterData(apiList){
    let importName="";
    let routergetName="";
    let routerpostName="";

    apiList.forEach(apiInfo => {
        importName+=`
        import * as ${apiInfo.name}Biz from '../biz/${apiInfo.name}';
        `

        routergetName+=`
        httpServer.get('/${apiInfo.name}', asyncHandler(${apiInfo.name}Biz.getData));
        `
        routerpostName+=`
        httpServer.post('/${apiInfo.name}', asyncHandler(${apiInfo.name}Biz.getData));
        `
    });

    let str=`
        import * as asyncHandler from 'express-async-handler'
        ${importName}

        export function srtRouter(httpServer){
            ${routergetName}
            ${routerpostName}
        }`
    return str;
}

//创建biz层
function createBiz(){
    RoutersheetNameList.forEach(apiInfo=>{
        let path = `./biz/${apiInfo.name}.ts`;
        fs.access(path, (err) => {
        if (!err) {
            console.error(path, "文件已存在");
            return;
        }
        
        fs.writeFileSync(path, getBizData(apiInfo.dataList));
        console.log(path, "创建biz文件成功")
        });
    })
}

function getBizData(dataList){
    let funStr="";
    let runFunStr="";
    dataList.forEach(dataInfo=>{
        let subFunStr=``;
        switch(dataInfo.type){
            case "键值":
                subFunStr=`mock键值数据模板(${dataInfo.len})`;
                break;
            case "键值":
                subFunStr=`mock柱状数据模板(${dataInfo.len})`;
                break;
            case "键值":
                subFunStr=`mock地图数据模板(${dataInfo.len})`;
                break;
        };
        funStr+=
`function get${dataInfo.name}(){
    return ${subFunStr};
}

`;

        runFunStr+=
`   ret["${dataInfo.name}"]=get${dataInfo.name}();
`
    });

    let allData=
`import { mock键值数据模板，mock柱状图数据模板，mock地图数据模板 } from "../util/mockData";

export async function getData(req, res){
    let ret:any = {};

${runFunStr}

    res.send(ret);
}

${funStr}
`

    return allData;
}

createData();
createRouter();
createBiz();

//创建 biz层



